

varying vec4 v_normal;
varying vec4 vertexPos;


uniform vec4 CAMERAPOS;
uniform vec4 LightSource;
uniform vec4 LightColor;

const vec4 specColor = vec4(1, 0, 1, 1);

vec4 effect( vec4 color, Image tex, vec2 texture_coords, vec2 screen_coords )
    {
        //litteraly just the wikipädia version of blinn phong lighting
        vec4 ambient = vec4(0.1, 0.1, 0.1, 1);
        vec4 vertexPosition = vec4(vertexPos);
        vec4 light_dir = LightSource - vertexPosition;
        float dist = length(light_dir);
        dist = dist * dist;
        light_dir = normalize(light_dir);

        float lambertian = max(dot(light_dir, v_normal), 0.0);
        float specular = 0.0;
        if (lambertian > 0.0) {
            vec4 viewDir = normalize(-vertexPos);
            vec4 halfDir = normalize(light_dir + viewDir);
            float specularAngle = max(dot(halfDir, v_normal), 0.0);
            specular = pow(specularAngle, 4);

        }
          vec4 colorLinear = ambient +
                     LightColor * lambertian * LightColor * 10 / dist +
                     specColor * specular * LightColor * 10 / dist;
        return vec4(colorLinear.rgb, 1.0);
    }